#include "ui_mainwindow.h"
#include "mainWindow.h"
#include "widgetData.h"
#include "widgetMaterial.h"
#include "widgetPlot.h"

MainWindow::MainWindow(QWidget *parent) :
  QMainWindow(parent),
  ui(new Ui::MainWindow)
{
  /*///////////////////////////////////////////////////////////////////////////////////*/
  /*////////////////////////// Repertoire de travail local ////////////////////////////*/
  /*///////////////////////////////////////////////////////////////////////////////////*/
  QDir::setCurrent(QDir::currentPath());

  /*///////////////////////////////////////////////////////////////////////////////////*/
  /*/////////////////////////// Definition du mainLayout //////////////////////////////*/
  /*///////////////////////////////////////////////////////////////////////////////////*/
  ui          ->setupUi(this);
  mainLayout  = new QGridLayout();
  ui          ->centralWidget->setLayout(mainLayout);

  /*///////////////////////////////////////////////////////////////////////////////////*/
  /*//////////////////////////////// Widget plotWidget ////////////////////////////////*/
  /*///////////////////////////////////////////////////////////////////////////////////*/
  plotWidget  = new widgetPlot(this);
  mainLayout  ->addWidget(plotWidget,   0, 1, 2, 1);
  plotWidget  ->setFixedWidth(600);
  plotWidget  ->setMinimumHeight(800);

  /*///////////////////////////////////////////////////////////////////////////////////*/
  /*/////////////////////////////// Widget matWidget //////////////////////////////////*/
  /*///////////////////////////////////////////////////////////////////////////////////*/
  matWidget   = new widgetMaterial(plotWidget, this);
  mainLayout  ->addWidget(matWidget,   1, 0, 1, 1);
  matWidget   ->setFixedWidth(600);

  /*///////////////////////////////////////////////////////////////////////////////////*/
  /*/////////////////////////////// Widget dataWidget /////////////////////////////////*/
  /*///////////////////////////////////////////////////////////////////////////////////*/
  dataWidget  = new widgetData(plotWidget, this);
  mainLayout  ->addWidget(dataWidget,   0, 0, 1, 1);
  dataWidget  ->setFixedWidth(600);
}

MainWindow::~MainWindow()
{
  delete ui;
}
