#ifndef WIDGETDATA_H
#define WIDGETDATA_H

#include <QSpinBox>
#include <QPushButton>
#include <QGridLayout>
#include <QPlainTextEdit>
#include <QProcess>
#include "widgetPlot.h"

class widgetData : public QWidget
{
  Q_OBJECT

public:
  explicit widgetData(widgetPlot *plotWidget, QWidget *parent = 0);
  ~widgetData();
    
public slots:
  void setDefault();
  void writeToTermBox(const QString &);
  void loadData();
  void reloadData();
  void fitData();
  void activatePoles();
  void activateFit();

private:
  QGridLayout *widgetDataLayout;
  QPushButton *loadDataButton, *reloadDataButton, *fitDataButton;
  QSpinBox *zeroOrderPoleSpinBox, *firstOrderPoleSpinBox, *secondOrderPoleSpinBox;
  QPlainTextEdit *termTextEdit;
  QString filename;
  widgetPlot *plotWidget, *plotWidgetLoc;
  QProcess *process;
};

#endif // WIDGETDATA_H
