#ifndef WIDGETMATERIAL_H
#define WIDGETMATERIAL_H

#include <QPushButton>
#include <QGridLayout>
#include <QListWidget>
#include <QProcess>
#include <QInputDialog>
#include "widgetPlot.h"

class widgetMaterial : public QWidget
{
  Q_OBJECT

public:
  explicit widgetMaterial(widgetPlot *plotWidget, QWidget *parent = 0);
  ~widgetMaterial();
    
public slots:
  void loadAllMaterials();
  void selectedMaterial(QListWidgetItem*);
  void plotData();
  void plotFit();
  void plotBoth();
  void deleteMaterial();
  void saveSelected();

private:
  QGridLayout *widgetMaterialLayout;
  QListWidget *materialList;
  QProcess *process;
  int nFiles, nMats;
  QPushButton *plotDataButton, *plotFitButton, *plotBothButton, *deleteMaterialButton;
  widgetPlot *plotWidget, *plotWidgetLoc;
  QString materialPath, currPath, dataFile, fitFile, fileName, model;
  QDialog *materialName;
};

#endif // WIDGETMATERIAL_H
