#ifndef WIDGETPLOT_H
#define WIDGETPLOT_H

#include <QGridLayout>
#include <QWidget>
#include <QPushButton>
#include <QFileInfo>
#include "qcustomplot.h"

class widgetPlot : public QWidget
{
  Q_OBJECT

public:
  explicit widgetPlot(QWidget *parent = 0);
  ~widgetPlot();
    
public slots: 
  void plotDataAndFit(QString filename); 
  void plotData(QString filename, bool doClearGraph);
  void plotFit(QString filename); 
  void selectGraphs(QCPAbstractPlottable*);
  void deselectGraphs();
  void removeSelectedGraph();
  void removeAllGraphs();
  void rescaleGraphs();
  void selectLegend(QCPLegend* legend, QCPAbstractLegendItem* legendItem);

public:
  QPushButton *removeSelectedButton, *removeAllButton, *rescaleButton, *saveSelectedButton;
  QCPAbstractPlottable *currentRealGraph, *currentImagGraph;
  QHash<QCPAbstractPlottable*,QFileInfo> realFileTable, imagFileTable;
  QHash<QCPAbstractPlottable*,QString> realTypeOfGraph, imagTypeOfGraph;

private:
  QGridLayout *widgetPlotLayout;
  QCustomPlot *realPlot, *imagPlot;
  QHash<QCPAbstractPlottable*,QCPAbstractPlottable*> graphTable;
  QVector<double> omega, epsReal, epsImag;
  QString filename;
  int zero, one, two;
  bool doClearGraph;
  QCPAbstractLegendItem *realLegendItem, *imagLegendItem;
};

#endif // WIDGETPLOT_H
