PROGRAM ADD_MESH_BOUNDARY
  !----------------------------------------------------------------------
  !---- Program for adding a missing mesh boundary
  !----------------------------------------------------------------------
  !---- Shared modules
  !----------------------------------------------------------------------
  USE MESH_APPS
  USE IO_FILES
  USE ISO_C_BINDING
  !----------------------------------------------------------------------
  IMPLICIT NONE
  !----------------------------------------------------------------------
  !---- Shared variable
  !----------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: readName, cBoundaryTag
  
  INTEGER(C_INT)                   :: nArg, boundaryTag
  !----------------------------------------------------------------------
  !---- Get arguments
  !----------------------------------------------------------------------
  nArg = COMMAND_ARGUMENT_COUNT()
  IF (nArg /= 2) THEN
     WRITE(6,'(a)') 'You did not provide the right number of arguments'
     WRITE(6,'(a)') 'Please provide:'
     WRITE(6,'(a)') '      - A mesh file'
     WRITE(6,'(a)') '      - A face tag'
     STOP     
  ENDIF
  !
  CALL GETARG(1,readName)
  CALL GETARG(2,cBoundaryTag)
  !
  CALL CHAR_TO_INT(cBoundaryTag, boundaryTag)
  !----------------------------------------------------------------------
  !---- Convert
  !----------------------------------------------------------------------
  CALL ADD_MESH_BOUNDARY_SUB(readName, boundaryTag)
  !----------------------------------------------------------------------
  WRITE(6,'(a)') 'I finished adding boundary faces'
  !----------------------------------------------------------------------
END PROGRAM ADD_MESH_BOUNDARY
