PROGRAM BUILD_CUBIC_MESH
  !------------------------------------------------------------------------
  !---- Program for building a regular cubic mesh
  !------------------------------------------------------------------------
  !---- Shared modules
  !------------------------------------------------------------------------
  USE MESH_APPS
  USE IO_FILES
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  !---- Shared variable
  !------------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: readname

  INTEGER(C_INT)                   :: nArg
  
  REAL(C_DOUBLE)                   :: scaling
  !----------------------------------------------------------------------
  !---- Get arguments
  !----------------------------------------------------------------------
  nArg = COMMAND_ARGUMENT_COUNT()
  IF (nArg /= 1) THEN
     WRITE(6,'(a)') 'You did not provide the right number of arguments'
     WRITE(6,'(a)') 'Please provide a configuration file'
     STOP
  ENDIF
  !
  CALL GETARG(1,readname)
  !------------------------------------------------------------------------
  !---- Build mesh
  !------------------------------------------------------------------------
  CALL BUILD_CUBIC_MESH_SUB(readName)
  !------------------------------------------------------------------------
  WRITE(6,'(a)') 'Finished building cubic mesh'
  !------------------------------------------------------------------------
END PROGRAM BUILD_CUBIC_MESH
