PROGRAM CHANGE_ELEMENT_TAG
  !----------------------------------------------------------------------
  !---- Change an element tag globally
  !----------------------------------------------------------------------
  !---- Shared modules
  !----------------------------------------------------------------------
  USE MESH_APPS
  USE IO_FILES
  USE MESH_FACES
  USE ISO_C_BINDING
  !----------------------------------------------------------------------
  IMPLICIT NONE
  !----------------------------------------------------------------------
  !---- Shared variable
  !----------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: readname, cOldTag, cNewTag, eltType

  INTEGER(C_INT)                   :: oldTag, newTag, nChange, nArg
  !----------------------------------------------------------------------
  !---- Get arguments
  !----------------------------------------------------------------------
  nArg = COMMAND_ARGUMENT_COUNT()
  IF (nArg /= 4) THEN
     WRITE(6,'(a)') 'You did not provide the right number of arguments'
     WRITE(6,'(a)') 'Please provide:'
     WRITE(6,'(a)') '      - A mesh file'
     WRITE(6,'(a)') '      - An element type (TRI, QUA, TET, HEX)'
     WRITE(6,'(a)') '      - The tag to modify'
     WRITE(6,'(a)') '      - The new tag'
     STOP
  ENDIF
  !
  CALL GETARG(1,readname)
  CALL GETARG(2,eltType)
  CALL GETARG(3,cOldTag)
  CALL GETARG(4,cNewTag)
  !
  CALL CHAR_TO_INT(cOldTag,oldTag)
  CALL CHAR_TO_INT(cNewTag,newTag)
  !----------------------------------------------------------------------
  !---- Change tag
  !----------------------------------------------------------------------
  checkForFaces = .FALSE.
  CALL CHANGE_ELEMENT_TAG_SUB(readName, eltType, oldTag, newTag, nChange)
  !----------------------------------------------------------------------
  WRITE(6,'(a,i0,a)') "I modified the reference of ",nChange," elements"
  !----------------------------------------------------------------------
END PROGRAM CHANGE_ELEMENT_TAG
