PROGRAM CONVERT_MESH
  !----------------------------------------------------------------------
  !---- Program for converting mesh formats
  !----------------------------------------------------------------------
  !---- Shared modules
  !----------------------------------------------------------------------
  USE MESH_APPS
  USE MESH_FACES
  USE ISO_C_BINDING
  !----------------------------------------------------------------------
  IMPLICIT NONE
  !----------------------------------------------------------------------
  !---- Shared variable
  !----------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: readName, outputExt
  
  INTEGER(C_INT)                   :: nArg
  !----------------------------------------------------------------------
  !---- Get arguments
  !----------------------------------------------------------------------
  nArg = COMMAND_ARGUMENT_COUNT()
  IF (nArg /= 2) THEN
     WRITE(6,'(a)') 'You did not provide the right number of arguments'
     WRITE(6,'(a)') 'Please provide:'
     WRITE(6,'(a)') '      - A mesh file'
     WRITE(6,'(a)') '      - A mesh extension'
     STOP
  ENDIF
  !
  CALL GETARG(1,readName)
  CALL GETARG(2,outputExt)
  !----------------------------------------------------------------------
  !---- Convert
  !----------------------------------------------------------------------
  checkForFaces = .FALSE.
  CALL CONVERT_MESH_SUB(readName, outputExt)
  !----------------------------------------------------------------------
  WRITE(6,'(a)') "I finished mesh conversion"
  !----------------------------------------------------------------------
END PROGRAM CONVERT_MESH
