PROGRAM CONVERT_SOLUTION
  !----------------------------------------------------------------------
  !---- Program for converting solution formats
  !----------------------------------------------------------------------
  !---- Shared modules
  !----------------------------------------------------------------------
  USE MESH_APPS
  USE MESH_FACES
  USE ISO_C_BINDING
  !----------------------------------------------------------------------
  IMPLICIT NONE
  !----------------------------------------------------------------------
  !---- Shared variable
  !----------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: meshName, solutionName, solutionExt
  
  INTEGER(C_INT)                   :: nArg
  !----------------------------------------------------------------------
  !---- Get arguments
  !----------------------------------------------------------------------
  nArg = COMMAND_ARGUMENT_COUNT()
  IF (nArg /= 3) THEN
     WRITE(6,'(a)') 'You did not provide the right number of arguments'
     WRITE(6,'(a)') 'Please provide:'
     WRITE(6,'(a)') '      - A mesh file'
     WRITE(6,'(a)') '      - A solution file'
     WRITE(6,'(a)') '      - A solution extension'
     STOP
  ENDIF
  !
  CALL GETARG(1,meshName)
  CALL GETARG(2,solutionName)
  CALL GETARG(3,solutionExt)
  !----------------------------------------------------------------------
  !---- Convert
  !----------------------------------------------------------------------
  checkForFaces = .FALSE.
  CALL CONVERT_SOLUTION_SUB(meshName, solutionName, solutionExt)
  !----------------------------------------------------------------------
  WRITE(6,'(a)') 'I finished solution conversion'
  !----------------------------------------------------------------------
END PROGRAM CONVERT_SOLUTION
