PROGRAM PARTITION_MESH
  !------------------------------------------------------------------------
  !---- Partition a mesh
  !------------------------------------------------------------------------
  !---- Shared modules
  !------------------------------------------------------------------------
  USE MESH_APPS
  USE IO_FILES
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  !---- Shared variable
  !------------------------------------------------------------------------
  LOGICAL(C_BOOL)                  :: hybridCut, periodicCut

  CHARACTER(LEN=1000, KIND=C_CHAR) :: readname, cDomains, arg

  INTEGER(C_INT)                   :: nDomains, nArg, iArg
  !------------------------------------------------------------------------
  !---- Get arguments
  !------------------------------------------------------------------------
  nArg = COMMAND_ARGUMENT_COUNT()
  IF ((nArg /= 2) .AND. (nArg /= 3) .AND. (nArg /=4)) THEN
     WRITE(6,'(a)') 'You did not provide the right number of arguments'
     WRITE(6,'(a)') 'Please provide:'
     WRITE(6,'(a)') '      - A mesh file'
     WRITE(6,'(a)') '      - A number of sudomains'
     WRITE(6,'(a)') '      - A "-noHybridCut"   tag (optional)'
     WRITE(6,'(a)') '      - A "-noPeriodicCut" tag (optional)'     
     STOP
  ENDIF
  !
  CALL GETARG(1,readname)
  CALL GETARG(2,cDomains)
  CALL CHAR_TO_INT(cDomains,nDomains)
  !
  hybridCut   = .TRUE.
  periodicCut = .TRUE.
  !
  DO iArg=3,nArg
     CALL GETARG(iArg,arg)
     !
     SELECT CASE (TRIM(arg))
     CASE('-noHybridCut')
        hybridCut = .FALSE.
     CASE('-noPeriodicCut')
        periodicCut = .FALSE.     
     CASE DEFAULT
        WRITE(6,'(a)') 'Unknown argument in command line'
        WRITE(6,'(a)') 'Maybe you meant "-noHybridCut" or "-noPeriodicCut"'
        CALL TILT
     END SELECT
  ENDDO
  !------------------------------------------------------------------------
  !---- Partition mesh
  !------------------------------------------------------------------------
  CALL PARTITION_MESH_SUB(readName, nDomains, hybridCut, periodicCut)
  !------------------------------------------------------------------------
  WRITE(6,'(a)') 'I finished partitioning mesh'
  !------------------------------------------------------------------------
END PROGRAM PARTITION_MESH
