PROGRAM ROTATE_MESH
  !------------------------------------------------------------------------
  !---- Program for rotating mesh node from axes and angle
  !
  !---- IN
  !---- mesh_name     : Name of the mesh in medit format
  !---- axes          : axes for the rotation
  !---- angle         : angle of the rotation
  !
  !---- OUT
  !---- *             : Translated mesh
  !------------------------------------------------------------------------
  !---- Shared modules
  !------------------------------------------------------------------------
  USE IO_FILES
  USE MESH_APPS
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  !---- Shared variable
  !------------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: readname, cAxesx, cAxesy, cAxesz, cTheta
  !
  REAL(C_DOUBLE)                   :: angle
  REAL(C_DOUBLE), DIMENSION(3)     :: axes
  !
  INTEGER(C_INT)                   :: nArg
  !------------------------------------------------------------------------
  !---- Get arguments
  !------------------------------------------------------------------------
  nArg = COMMAND_ARGUMENT_COUNT()
  IF (nArg /= 5) THEN
     WRITE(6,'(a)') 'You did not provide the right number of arguments'
     WRITE(6,'(a)') 'Please provide:'
     WRITE(6,'(a)') '      - A mesh file'
     WRITE(6,'(a)') '      - A x axes value'
     WRITE(6,'(a)') '      - A y axes value'
     WRITE(6,'(a)') '      - A z axes value'
     WRITE(6,'(a)') '      - A t angle value'
     STOP
  ENDIF

  CALL GETARG(1,readname)
  CALL GETARG(2,cAxesx)
  CALL GETARG(3,cAxesy)
  CALL GETARG(4,cAxesz)
  CALL GETARG(5,cTheta)
  !
  CALL CHAR_TO_DOUBLE(cAxesx, axes(1))
  CALL CHAR_TO_DOUBLE(cAxesy, axes(2))
  CALL CHAR_TO_DOUBLE(cAxesz, axes(3))
  CALL CHAR_TO_DOUBLE(cTheta, angle)
  !------------------------------------------------------------------------
  !---- Rotate mesh
  !------------------------------------------------------------------------
  CALL ROTATE_MESH_SUB(readName, axes, angle)
  !------------------------------------------------------------------------
  WRITE(6,'(4a,e12.2,e12.2,e12.2,a,e12.2)') 'Mesh was rotate from axes=[',axes,'] with angle =',angle
  !------------------------------------------------------------------------
END PROGRAM ROTATE_MESH
