PROGRAM SCALE_MESH
  !------------------------------------------------------------------------
  !---- Program for scaling mesh node coordinates by a given factor
  !------------------------------------------------------------------------
  !---- Shared modules
  !------------------------------------------------------------------------
  USE MESH_APPS
  USE IO_FILES
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  !---- Shared variable
  !------------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: readname, cscaling

  INTEGER(C_INT)                   :: nArg
  
  REAL(C_DOUBLE)                   :: scaling
  !----------------------------------------------------------------------
  !---- Get arguments
  !----------------------------------------------------------------------
  nArg = COMMAND_ARGUMENT_COUNT()
  IF (nArg /= 2) THEN
     WRITE(6,'(a)') 'You did not provide the right number of arguments'
     WRITE(6,'(a)') 'Please provide:'
     WRITE(6,'(a)') '      - A mesh file'
     WRITE(6,'(a)') '      - A scaling factor'
     STOP
  ENDIF
  !
  CALL GETARG(1,readname)
  CALL GETARG(2,cscaling)
  !
  CALL CHAR_TO_DOUBLE(cscaling, scaling)
  !------------------------------------------------------------------------
  !---- Scale mesh
  !------------------------------------------------------------------------
  CALL SCALE_MESH_SUB(readName, scaling)
  !------------------------------------------------------------------------
  WRITE(6,'(a,e12.5)') 'Mesh was scaled by factor :',scaling
  !------------------------------------------------------------------------
END PROGRAM SCALE_MESH
