PROGRAM SYMMETRISE_MESH
  !------------------------------------------------------------------------
  !---- Program for symmetrise a mesh from one of his plane
  !------------------------------------------------------------------------
  !---- Shared modules
  !------------------------------------------------------------------------
  USE MESH_APPS
  USE IO_FILES
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  !---- Shared variable
  !------------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: readname, cPlane

  INTEGER(C_INT)                   :: nArg
  !----------------------------------------------------------------------
  !---- Get arguments
  !----------------------------------------------------------------------
  nArg = COMMAND_ARGUMENT_COUNT()
  IF (nArg /= 2) THEN
     WRITE(6,'(a)') 'You did not provide the right number of arguments'
     WRITE(6,'(a)') 'Please provide:'
     WRITE(6,'(a)') '      - A mesh file'
     WRITE(6,'(a)') '      - A plane (x1, x2, y1, y2, z1, z2)'
     STOP
  ENDIF
  !
  CALL GETARG(1,readname)
  CALL GETARG(2,cPlane)
  !------------------------------------------------------------------------
  !---- Scale mesh
  !------------------------------------------------------------------------
  CALL SYMMETRISE_MESH_SUB(readName, cPlane)
  !------------------------------------------------------------------------
  WRITE(6,'(a)') 'Mesh was symmetrise'
  !------------------------------------------------------------------------
END PROGRAM SYMMETRISE_MESH
