PROGRAM TRANSLATE_MESH
  !------------------------------------------------------------------------
  !---- Program for translating mesh node coordinates by a given vector
  !------------------------------------------------------------------------
  !---- Shared modules
  !------------------------------------------------------------------------
  USE IO_FILES
  USE MESH_APPS
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  !---- Shared variable
  !------------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: readname, cvectorx, cvectory, cvectorz
  !
  REAL(C_DOUBLE), DIMENSION(3)     :: vector
  !
  INTEGER(C_INT)                   :: nArg
  !----------------------------------------------------------------------
  !---- Get arguments
  !----------------------------------------------------------------------
  nArg = COMMAND_ARGUMENT_COUNT()
  IF (nArg /= 4) THEN
     WRITE(6,'(a)') 'You did not provide the right number of arguments'
     WRITE(6,'(a)') 'Please provide:'
     WRITE(6,'(a)') '      - A mesh file'
     WRITE(6,'(a)') '      - An x translation value'
     WRITE(6,'(a)') '      - An y translation value'
     WRITE(6,'(a)') '      - A  z translation value'
     STOP
  ENDIF
  !
  CALL GETARG(1,readname)
  CALL GETARG(2,cvectorx)
  CALL GETARG(3,cvectory)
  CALL GETARG(4,cvectorz)
  !
  CALL CHAR_TO_DOUBLE(cvectorx, vector(1))
  CALL CHAR_TO_DOUBLE(cvectory, vector(2))
  CALL CHAR_TO_DOUBLE(cvectorz, vector(3))
  !------------------------------------------------------------------------
  !---- Translate mesh
  !------------------------------------------------------------------------
  CALL TRANSLATE_MESH_SUB(readName, vector)
  !------------------------------------------------------------------------
  WRITE(6,'(a,3f12.5,a)') 'Mesh was translate by v=[',vector,']'
  !------------------------------------------------------------------------
END PROGRAM TRANSLATE_MESH
