MODULE TAGADA

  !========================================================================
  ! Description of module TAGADA
  !========================================================================

  !------------------------------------------------------------------------
  ! Shared modules
  !------------------------------------------------------------------------
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  ! Description of data structure tsouintsouin_structure
  ! 
  ! value   ==> description of value
  ! measure ==> description of measure
  ! array   ==> description of array
  !------------------------------------------------------------------------
  TYPE tsouintsouin_structure
     INTEGER(C_INT) :: value

     REAL(C_DOUBLE), DIMENSION(3) :: measure
     REAL(C_DOUBLE), DIMENSION(:), ALLOCATABLE :: array
  END TYPE tsouintsouin_structure
  !------------------------------------------------------------------------
  ! Global tsouintsouin structure
  ! Additional comments on that structure
  !------------------------------------------------------------------------
  TYPE(tsouintsouin_structure), DIMENSION(:), ALLOCATABLE :: Marguerite
  !------------------------------------------------------------------------

CONTAINS

  !========================================================================
  !========================================================================
  !========================================================================

  SUBROUTINE YOUPLABOUM(seed, flower)
    !----------------------------------------------------------------------
    !---- Description of subroutine YOUPLABOUM
    !
    !---- IN:
    !---- seed   : Just a seed for a flower
    !
    !---- OUT:
    !---- flower : The final flower !
    !----------------------------------------------------------------------
    !---- Modules
    !----------------------------------------------------------------------
    USE THIS_MODULE
    USE THAT_MODULE
    !----------------------------------------------------------------------
    !---- I/O variables
    !----------------------------------------------------------------------
    REAL(C_DOUBLE), INTENT(IN)  :: seed
    REAL(C_DOUBLE), INTENT(OUT) :: flower
    !----------------------------------------------------------------------
    !---- Local variables
    !----------------------------------------------------------------------
    REAL(C_DOUBLE) :: water, earth, fertilizer, clown
    !----------------------------------------------------------------------
    !---- Testing for bad input
    !----------------------------------------------------------------------
    IF (seed < 0.0) THEN
       print*, 'Seed is supposed to be positive'
       print*, 'Received value',seed,'for seed'
       print*, 'Exiting'
       STOP
    ENDIF
    !----------------------------------------------------------------------
    !---- Initialize data
    !----------------------------------------------------------------------
    !---- flower is INTENT(OUT) so I can modify it
    !---- However I should not touch seed, which is INTENT(IN)
    flower     = 0.0
    water      = 2.0e+1
    earth      = 1.0e-1
    fertilizer = 3.0
    clown      = 1.0 ! What does that clown have to do with this ?
    !----------------------------------------------------------------------
    !---- Let the seed become a flower
    !----------------------------------------------------------------------
    !---- Start with the seed
    flower = flower + seed
    !
    !---- Add water and fertilizer
    flower = flower + water + fertilizer
    !
    !---- Multiply by clown
    flower = flower*clown
    !----------------------------------------------------------------------
    !---- Testing for errors
    !----------------------------------------------------------------------
    IF (flower > 10.0) THEN
       print*, 'Flower too high !'
       STOP
    ENDIF
    !----------------------------------------------------------------------
1   FORMAT(1(ai0)a) ! Format pour un truc
2   FORMAT(2(ai0)a) ! Format pour un bidule
    !----------------------------------------------------------------------
  END SUBROUTINE YOUPLABOUM

  !========================================================================
  !========================================================================
  !========================================================================

  SUBROUTINE YOUPLABOUM(seed, flower)
    !----------------------------------------------------------------------
    !---- Description of subroutine YOUPLABOUM
    !
    !---- IN:
    !---- seed   : Just a seed for a flower
    !
    !---- OUT:
    !---- flower : The final flower !
    !----------------------------------------------------------------------
    !---- Modules
    !----------------------------------------------------------------------
    USE THIS_MODULE
    USE THAT_MODULE
    !----------------------------------------------------------------------
    !---- I/O variables
    !----------------------------------------------------------------------
    REAL(C_DOUBLE), INTENT(IN)  :: seed
    REAL(C_DOUBLE), INTENT(OUT) :: flower
    !----------------------------------------------------------------------
    !---- Local variables
    !----------------------------------------------------------------------
    REAL(C_DOUBLE) :: water, earth, fertilizer, clown
    !----------------------------------------------------------------------
    !---- Testing for bad input
    !----------------------------------------------------------------------
    IF (seed < 0.0) THEN
       print*, 'Seed is supposed to be positive'
       print*, 'Received value',seed,'for seed'
       print*, 'Exiting'
       STOP
    ENDIF
    !----------------------------------------------------------------------
    !---- Initialize data
    !----------------------------------------------------------------------
    !---- flower is INTENT(OUT) so I can modify it
    !---- However I should not touch seed, which is INTENT(IN)
    flower     = 0.0
    water      = 2.0e+1
    earth      = 1.0e-1
    fertilizer = 3.0
    clown      = 1.0 ! What does that clown have to do with this ?
    !----------------------------------------------------------------------
    !---- Let the seed become a flower
    !----------------------------------------------------------------------
    !---- Start with the seed
    flower = flower + seed
    !
    !---- Add water and fertilizer
    flower = flower + water + fertilizer
    !
    !---- Multiply by clown
    flower = flower*clown
    !----------------------------------------------------------------------
    !---- Testing for errors
    !----------------------------------------------------------------------
    IF (flower > 10.0) THEN
       print*, 'Flower too high !'
       STOP
    ENDIF
    !----------------------------------------------------------------------
1   FORMAT(1(ai0)a) ! Format pour un truc
2   FORMAT(2(ai0)a) ! Format pour un bidule
    !----------------------------------------------------------------------
  END SUBROUTINE YOUPLABOUM

  !========================================================================
  !========================================================================
  !========================================================================

END MODULE TAGADA

