MODULE LIBMESH

  !========================================================================
  ! Module for interface with libmesh
  !========================================================================

  !------------------------------------------------------------------------
  ! Shared modules
  !------------------------------------------------------------------------
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------

  INTEGER GmfMaxTyp
  INTEGER GmfMaxKwd
  INTEGER GmfRead
  INTEGER GmfWrite
  INTEGER GmfSca
  INTEGER GmfVec
  INTEGER GmfSymMat
  INTEGER GmfMat
  INTEGER GmfFloat
  INTEGER GmfDouble

  PARAMETER (GmfMaxTyp=1000)
  PARAMETER (GmfMaxKwd=81)
  PARAMETER (GmfRead=1)
  PARAMETER (GmfWrite=2)
  PARAMETER (GmfSca=1)
  PARAMETER (GmfVec=2)
  PARAMETER (GmfSymMat=3)
  PARAMETER (GmfMat=4)
  PARAMETER (GmfFloat=1)
  PARAMETER (GmfDouble=2)

  INTEGER GmfMeshVersionFormatted
  INTEGER GmfDimension
  INTEGER GmfVertices
  INTEGER GmfEdges
  INTEGER GmfTriangles
  INTEGER GmfQuadrilaterals
  INTEGER GmfTetrahedra
  INTEGER GmfPrisms
  INTEGER GmfHexahedra
  INTEGER GmfIterationsAll
  INTEGER GmfTimesAll
  INTEGER GmfCorners
  INTEGER GmfRidges
  INTEGER GmfRequiredVertices
  INTEGER GmfRequiredEdges
  INTEGER GmfRequiredTriangles
  INTEGER GmfRequiredQuadrilaterals
  INTEGER GmfTangentAtEdgeVertices
  INTEGER GmfNormalAtVertices
  INTEGER GmfNormalAtTriangleVertices
  INTEGER GmfNormalAtQuadrilateralVertices
  INTEGER GmfAngleOfCornerBound
  INTEGER GmfTrianglesP2
  INTEGER GmfEdgesP2
  INTEGER GmfSolAtPyramids
  INTEGER GmfQuadrilateralsQ2
  INTEGER GmfISolAtPyramids
  INTEGER GmfSubDomainFromGeom
  INTEGER GmfTetrahedraP2
  INTEGER GmfFault_NearTri
  INTEGER GmfFault_Inter
  INTEGER GmfHexahedraQ2
  INTEGER GmfExtraVerticesAtEdges
  INTEGER GmfExtraVerticesAtTriangles
  INTEGER GmfExtraVerticesAtQuadrilaterals
  INTEGER GmfExtraVerticesAtTetrahedra
  INTEGER GmfExtraVerticesAtPrisms
  INTEGER GmfExtraVerticesAtHexahedra
  INTEGER GmfVerticesOnGeometricVertices
  INTEGER GmfVerticesOnGeometricEdges
  INTEGER GmfVerticesOnGeometricTriangles
  INTEGER GmfVerticesOnGeometricQuadrilaterals
  INTEGER GmfEdgesOnGeometricEdges
  INTEGER GmfFault_FreeEdge
  INTEGER GmfPolyhedra
  INTEGER GmfPolygons
  INTEGER GmfFault_Overlap
  INTEGER GmfPyramids
  INTEGER GmfBoundingBox
  INTEGER GmfBody
  INTEGER GmfPrivateTable
  INTEGER GmfFault_BadShape
  INTEGER GmfEnd
  INTEGER GmfTrianglesOnGeometricTriangles
  INTEGER GmfTrianglesOnGeometricQuadrilaterals
  INTEGER GmfQuadrilateralsOnGeometricTriangles
  INTEGER GmfQuadrilateralsOnGeometricQuadrilaterals
  INTEGER GmfTangents
  INTEGER GmfNormals
  INTEGER GmfTangentAtVertices
  INTEGER GmfSolAtVertices
  INTEGER GmfSolAtEdges
  INTEGER GmfSolAtTriangles
  INTEGER GmfSolAtQuadrilaterals
  INTEGER GmfSolAtTetrahedra
  INTEGER GmfSolAtPrisms
  INTEGER GmfSolAtHexahedra
  INTEGER GmfDSolAtVertices
  INTEGER GmfISolAtVertices
  INTEGER GmfISolAtEdges
  INTEGER GmfISolAtTriangles
  INTEGER GmfISolAtQuadrilaterals
  INTEGER GmfISolAtTetrahedra
  INTEGER GmfISolAtPrisms
  INTEGER GmfISolAtHexahedra
  INTEGER GmfIterations
  INTEGER GmfTime
  INTEGER GmfFault_SmallTri
  INTEGER GmfCoarseHexahedra
  INTEGER GmfComments

  PARAMETER (GmfMeshVersionFormatted=1)
  PARAMETER (GmfDimension=3)
  PARAMETER (GmfVertices=4)
  PARAMETER (GmfEdges=5)
  PARAMETER (GmfTriangles=6)
  PARAMETER (GmfQuadrilaterals=7)
  PARAMETER (GmfTetrahedra=8)
  PARAMETER (GmfPrisms=9)
  PARAMETER (GmfHexahedra=10)
  PARAMETER (GmfIterationsAll=11)
  PARAMETER (GmfTimesAll=12)
  PARAMETER (GmfCorners=13)
  PARAMETER (GmfRidges=14)
  PARAMETER (GmfRequiredVertices=15)
  PARAMETER (GmfRequiredEdges=16)
  PARAMETER (GmfRequiredTriangles=17)
  PARAMETER (GmfRequiredQuadrilaterals=18)
  PARAMETER (GmfTangentAtEdgeVertices=19)
  PARAMETER (GmfNormalAtVertices=20)
  PARAMETER (GmfNormalAtTriangleVertices=21)
  PARAMETER (GmfNormalAtQuadrilateralVertices=22)
  PARAMETER (GmfAngleOfCornerBound=23)
  PARAMETER (GmfTrianglesP2=24)
  PARAMETER (GmfEdgesP2=25)
  PARAMETER (GmfSolAtPyramids=26)
  PARAMETER (GmfQuadrilateralsQ2=27)
  PARAMETER (GmfISolAtPyramids=28)
  PARAMETER (GmfSubDomainFromGeom=29)
  PARAMETER (GmfTetrahedraP2=30)
  PARAMETER (GmfFault_NearTri=31)
  PARAMETER (GmfFault_Inter=32)
  PARAMETER (GmfHexahedraQ2=33)
  PARAMETER (GmfExtraVerticesAtEdges=34)
  PARAMETER (GmfExtraVerticesAtTriangles=35)
  PARAMETER (GmfExtraVerticesAtQuadrilaterals=36)
  PARAMETER (GmfExtraVerticesAtTetrahedra=37)
  PARAMETER (GmfExtraVerticesAtPrisms=38)
  PARAMETER (GmfExtraVerticesAtHexahedra=39)
  PARAMETER (GmfVerticesOnGeometricVertices=40)
  PARAMETER (GmfVerticesOnGeometricEdges=41)
  PARAMETER (GmfVerticesOnGeometricTriangles=42)
  PARAMETER (GmfVerticesOnGeometricQuadrilaterals=43)
  PARAMETER (GmfEdgesOnGeometricEdges=44)
  PARAMETER (GmfFault_FreeEdge=45)
  PARAMETER (GmfPolyhedra=46)
  PARAMETER (GmfPolygons=47)
  PARAMETER (GmfFault_Overlap=48)
  PARAMETER (GmfPyramids=49)
  PARAMETER (GmfBoundingBox=50)
  PARAMETER (GmfBody=51)
  PARAMETER (GmfPrivateTable=52)
  PARAMETER (GmfFault_BadShape=53)
  PARAMETER (GmfEnd=54)
  PARAMETER (GmfTrianglesOnGeometricTriangles=55)
  PARAMETER (GmfTrianglesOnGeometricQuadrilaterals=56)
  PARAMETER (GmfQuadrilateralsOnGeometricTriangles=57)
  PARAMETER (GmfQuadrilateralsOnGeometricQuadrilaterals=58)
  PARAMETER (GmfTangents=59)
  PARAMETER (GmfNormals=60)
  PARAMETER (GmfTangentAtVertices=61)
  PARAMETER (GmfSolAtVertices=62)
  PARAMETER (GmfSolAtEdges=63)
  PARAMETER (GmfSolAtTriangles=64)
  PARAMETER (GmfSolAtQuadrilaterals=65)
  PARAMETER (GmfSolAtTetrahedra=66)
  PARAMETER (GmfSolAtPrisms=67)
  PARAMETER (GmfSolAtHexahedra=68)
  PARAMETER (GmfDSolAtVertices=69)
  PARAMETER (GmfISolAtVertices=70)
  PARAMETER (GmfISolAtEdges=71)
  PARAMETER (GmfISolAtTriangles=72)
  PARAMETER (GmfISolAtQuadrilaterals=73)
  PARAMETER (GmfISolAtTetrahedra=74)
  PARAMETER (GmfISolAtPrisms=75)
  PARAMETER (GmfISolAtHexahedra=76)
  PARAMETER (GmfIterations=77)
  PARAMETER (GmfTime=78)
  PARAMETER (GmfFault_SmallTri=79)
  PARAMETER (GmfCoarseHexahedra=80)
  PARAMETER (GmfComments=81)
  !------------------------------------------------------------------------

END MODULE LIBMESH
