MODULE QUADRATURES_1D

  !======================================================================
  ! Quadrature rules for segment [-1,1]
  !======================================================================

  !----------------------------------------------------------------------
  ! Shared modules
  !----------------------------------------------------------------------
  USE ISO_C_BINDING
  !----------------------------------------------------------------------
  IMPLICIT NONE
  !----------------------------------------------------------------------

  !----------------------------------------------------------------------
  ! Quadrature arrays on [-1,1]
  !----------------------------------------------------------------------
  ! q1p2 ==> 2-point quadrature rule
  ! q1p5 ==> 3-point quadrature rule
  ! q1p7 ==> 4-point quadrature rule
  ! q1p9 ==> 5-point quadrature rule
  !----------------------------------------------------------------------
  REAL(C_DOUBLE), DIMENSION(2,2) :: q1p2 = RESHAPE( (/  &
       +0.5773502691896257, 1.,                         &
       -0.5773502691896257, 1. /),                 (/2,2/))
  REAL(C_DOUBLE), DIMENSION(2,3) :: q1p5 = RESHAPE( (/  &
       +0.0,                0.8888888888888889,         &
       +0.7745966692414834, 0.5555555555555556,         &
       -0.7745966692414834, 0.5555555555555556 /), (/2,3/))
  REAL(C_DOUBLE), DIMENSION(2,4) :: q1p7 = RESHAPE( (/  &
       -0.33998104358486,   0.65214515486255,           &
       +0.33998104358486,   0.65214515486255,           &
       -0.86113631159405,   0.34785484513745,           &
       +0.86113631159405,   0.34785484513745 /),   (/2,4/))
  REAL(C_DOUBLE), DIMENSION(2,5) :: q1p9 = RESHAPE( (/  &
       +0.0,                0.56888888888889,           &
       +0.53846931010568,   0.47862867049937,           &
       +0.90617984593866,   0.23692688505619,           &
       -0.53846931010568,   0.47862867049937,           &
       -0.90617984593866,   0.23692688505619 /),   (/2,5/))
  !----------------------------------------------------------------------

END MODULE QUADRATURES_1D
