PROGRAM IO_TOOLSTEST
  !------------------------------------------------------------------------
  !---- Test program for IO_FILES tools
  !------------------------------------------------------------------------
  !---- Shared modules
  !------------------------------------------------------------------------
  USE IO_FILES
  USE IO_TESTS
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  !---- Shared variables
  !------------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: testName = 'IO_TOOLS'
  CHARACTER(LEN=1000, KIND=C_CHAR) :: repo     = '../../../tst/IO_tools/'  
  CHARACTER(LEN=1, KIND=C_CHAR)    :: char
  
  INTEGER(C_INT)                   :: nRows, nCols, intVal, nUnit, testNumber
  !------------------------------------------------------------------------
  !---- Move to test repository
  !------------------------------------------------------------------------
  CALL MOVE_TO_REPO(repo)  
  !------------------------------------------------------------------------
  !---- Test #1 : file unit provider (GET_NEW_FILE_UNIT)
  !------------------------------------------------------------------------
  testNumber = 1
  CALL GET_NEW_FILE_UNIT(nUnit)
  CALL GET_NEW_FILE_UNIT(nUnit)
  CALL GET_NEW_FILE_UNIT(nUnit)
  CALL GET_NEW_FILE_UNIT(nUnit)
  CALL GET_NEW_FILE_UNIT(nUnit)
  
  IF (nUnit /= 15) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
  !---- Test #2 : File full of integers (GET_SIZE_OF_FILE)
  !------------------------------------------------------------------------
  testNumber = 2
  CALL GET_SIZE_OF_FILE('test_int_file',nRows,nCols)
  !
  IF ((nRows /= 5) .OR. (nCols /= 3)) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
  !---- Test #3 : File full of reals (GET_SIZE_OF_FILE)
  !------------------------------------------------------------------------
  testNumber = 3
  CALL GET_SIZE_OF_FILE('test_real_file',nRows,nCols)
  !
  IF ((nRows /= 5) .OR. (nCols /= 3)) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
  !---- Test #4 : Regular conversion of char to int (CHAR_TO_INT)
  !------------------------------------------------------------------------
  testNumber = 4
  CALL CHAR_TO_INT('3',intVal)
  !
  IF (intVal /= 3) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
  !---- Test #5 : Regular conversion of int to char (INT_TO_CHAR)
  !------------------------------------------------------------------------
  testNumber = 5
  CALL INT_TO_CHAR(3,char)
  !
  IF (char /= '3') CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
END PROGRAM IO_TOOLSTEST
