PROGRAM ARRAY_OPERATIONSTEST
  !------------------------------------------------------------------------
  !---- Test program for array operations module
  !------------------------------------------------------------------------
  !---- Shared modules
  !------------------------------------------------------------------------
  USE IO_TESTS
  USE ARRAY_OPERATIONS
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  !---- Shared variables
  !------------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: testName = 'ARRAY_OPERATIONS'
  CHARACTER(LEN=1000, KIND=C_CHAR) :: repo     = '../../../tst/array_operations/'  

  LOGICAL(C_BOOL)                  :: isFound

  INTEGER(C_INT)                   :: nSorted, testNumber
  INTEGER(C_INT), DIMENSION(4)     :: sortedList
  INTEGER(C_INT), DIMENSION(6)     :: intDuplicateArray, intArray, sortedList2

  REAL(C_DOUBLE)                   :: tol
  REAL(C_DOUBLE), DIMENSION(2,4)   :: realNoDuplicateArray, realDuplicateArray 
  !------------------------------------------------------------------------
  !---- Initialize test matrices
  !------------------------------------------------------------------------
  DATA realNoDuplicateArray/1.0, 2.0, 3.0, 4.0, 2.0, 3.0, 4.0, 5.0/
  DATA   realDuplicateArray/1.0, 2.0, 1.0, 2.0, 2.0, 3.0, 2.0, 3.0/
  DATA    intDuplicateArray/1,   2,   1,   1,   1,   7/
  DATA             intArray/1,   2,   5,  12,   8,   7/
  !------------------------------------------------------------------------
  !---- Move to test repository
  !------------------------------------------------------------------------
  CALL MOVE_TO_REPO(repo)  
  !------------------------------------------------------------------------
  !---- Test #1 : Real array with no duplicates (FIND_ARRAY_DUPLICATES)
  !------------------------------------------------------------------------
  testNumber = 1
  tol        = 0.1
  CALL FIND_ARRAY_DUPLICATES(realNoDuplicateArray, 4, 2, tol, sortedList, nSorted)
  !
  IF (nSorted /= 4) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
  !---- Test #2 : Real array with 2 simple duplicates (FIND_ARRAY_DUPLICATES)
  !------------------------------------------------------------------------
  testNumber = 2
  tol        = 0.1
  CALL FIND_ARRAY_DUPLICATES(realDuplicateArray, 4, 2, tol, sortedList, nSorted)
  !
  IF (nSorted /= 2) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
  !---- Test #3 : Integer array with 1 quadruple duplicate (FIND_ARRAY_DUPLICATES)
  !------------------------------------------------------------------------
  testNumber = 3
  CALL FIND_ARRAY_DUPLICATES(intDuplicateArray, 6, sortedList2, nSorted)
  !
  IF (nSorted /= 3) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
  !---- Test #4 : Integer array with a single occurence (FIND_INT_IN_ARRAY)
  !------------------------------------------------------------------------
  testNumber = 4
  CALL FIND_INT_IN_ARRAY(intArray, 6, 8, isFound)
  !
  IF (.NOT. isFound) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
END PROGRAM ARRAY_OPERATIONSTEST
