PROGRAM SORTTEST
  !------------------------------------------------------------------------
  !---- Test program for sorting routines
  !------------------------------------------------------------------------
  !---- Shared modules
  !------------------------------------------------------------------------
  USE SORT  
  USE IO_TESTS
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  !---- Shared variables
  !------------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: testName = 'SORT'
  CHARACTER(LEN=1000, KIND=C_CHAR) :: repo     = '../../../tst/sort/'  
  
  INTEGER(C_INT)                   :: testNumber
  INTEGER(C_INT), DIMENSION(5)     :: list1, sortedList1
  INTEGER(C_INT), DIMENSION(3,3)   :: bigListInt, sortedBigListInt

  REAL(C_DOUBLE), DIMENSION(3,3)   :: bigListDble, sortedBigListDble
  !------------------------------------------------------------------------
  !---- Move to test repository
  !------------------------------------------------------------------------
  CALL MOVE_TO_REPO(repo)  
  !------------------------------------------------------------------------
  !---- Initialize test lists
  !------------------------------------------------------------------------
  DATA       list1/1, 7, 2, 45, 28/
  DATA sortedList1/1, 2, 7, 28, 45/
  !
  bigListInt =        RESHAPE( (/&
       7, 5, 3,       &
       2, 1, 2,       &
       2, 3, 4/), (/3,3/) )
  sortedBigListInt =  RESHAPE( (/&
       2, 1, 2,       &
       2, 3, 4,       &
       7, 5, 3/), (/3,3/) )
  bigListDble =       RESHAPE( (/&
       7.0, 5.0, 3.0, &
       2.0, 1.0, 2.0, &
       2.0, 3.0, 4.0/), (/3,3/) )
  sortedBigListDble = RESHAPE( (/&
       2.0, 1.0, 2.0, &
       2.0, 3.0, 4.0, &
       7.0, 5.0, 3.0/), (/3,3/) )  
  !------------------------------------------------------------------------
  !---- Test #1 : Non-sorted list as input with insertion sort
  !------------------------------------------------------------------------
  testNumber = 1
  CALL INSERTION_SORT_INT(list1)
  !
  IF (.NOT. (ALL(list1 .EQ. sortedList1))) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
  !---- Test #2 : Lexicographic sort of an integer array
  !------------------------------------------------------------------------
  testNumber = 2  
  CALL SORT_ARRAY(3, 3, bigListInt)
  !
  IF (.NOT. (ALL(bigListInt .EQ. sortedBigListInt))) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
  !---- Test #3 : Lexicographic sort of a double array
  !------------------------------------------------------------------------
  testNumber = 3  
  CALL SORT_ARRAY(3, 3, bigListDble)
  !
  IF (.NOT. (ALL(bigListDble .EQ. sortedBigListDble))) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------  
END PROGRAM SORTTEST
