PROGRAM TEST_TRANSLATETEST
  !------------------------------------------------------------------------
  !---- Test program for translate mesh
  !------------------------------------------------------------------------
  !---- Shared modules
  !------------------------------------------------------------------------
  USE MESH_DATA
  USE IO_FILES
  USE IO_TESTS
  USE MESH_STRUCTURES
  USE MESH_STATS
  USE MESH_VERTICES
  USE ISO_C_BINDING
  !------------------------------------------------------------------------
  IMPLICIT NONE
  !------------------------------------------------------------------------
  !---- Shared variables
  !------------------------------------------------------------------------
  CHARACTER(LEN=1000, KIND=C_CHAR) :: readname
  CHARACTER(LEN=1000, KIND=C_CHAR) :: testName = 'TRANSLATE_MESH'
  CHARACTER(LEN=1000, KIND=C_CHAR) :: repo     = '../../../tst/translate_mesh/'

  LOGICAL(C_BOOL)                  :: file_exists

  INTEGER(C_INT)                   :: testNumber

  REAL(C_DOUBLE)                   :: bbx1, bby1, bbz1, bbx2, bby2, bbz2, &
       xmin1, ymin1, zmin1, xmin2, ymin2, zmin2
  REAL(C_DOUBLE), DIMENSION(3)     :: vector
  !------------------------------------------------------------------------
  !---- Move to test repository
  !------------------------------------------------------------------------
  CALL MOVE_TO_REPO(repo)
  !------------------------------------------------------------------------
  !---- Test #1
  !------------------------------------------------------------------------
  testNumber = 1
  readname   = 'test.nmesh'
  vector(1)  = 1
  vector(2)  = 1
  vector(3)  = 1
  !
  CALL INITIALIZE_MESH_STRUCTURE(Mesh)
  CALL CHECK_IN_MESH_EXTENSION(readname)
  !
  CALL READ_MESH
  CALL COMPUTE_MESH_BOUNDING_BOX
  !
  xmin1=MeshVert(1)%coor(1)
  ymin1=MeshVert(1)%coor(2)
  zmin1=MeshVert(1)%coor(3)
  !
  bbx1=ABS(Mesh%coorMin(1)-Mesh%coorMax(1))
  bby1=ABS(Mesh%coorMin(2)-Mesh%coorMax(2))
  bbz1=ABS(Mesh%coorMin(3)-Mesh%coorMax(3))
  !
  CALL TRANSLATE_MESH_COORDINATES(vector)
  CALL COMPUTE_MESH_BOUNDING_BOX
  !
  xmin2=MeshVert(1)%coor(1)
  ymin2=MeshVert(1)%coor(2)
  zmin2=MeshVert(1)%coor(3)
  !
  bbx2=ABS(Mesh%coorMin(1)-Mesh%coorMax(1))
  bby2=ABS(Mesh%coorMin(2)-Mesh%coorMax(2))
  bbz2=ABS(Mesh%coorMin(3)-Mesh%coorMax(3))
  !------------------------------------------------------------------------
  !---- Test if the bb size is the same
  !---- & if we have keep the vector length between one point
  !------------------------------------------------------------------------
  testNumber = 1
  IF ( (bbx1 /= bbx2)               .OR. &
       (bby1 /= bby2)               .OR. &
       (bbz1 /= bbz2)               .OR. &
       (xmin2 - xmin1 /= vector(1)) .OR. &
       (ymin2 - ymin1 /= vector(2)) .OR. &
       (zmin2 - zmin1 /= vector(3))) CALL PRINT_TEST_ERROR_MESSAGE(testName, testNumber)
  !------------------------------------------------------------------------
END PROGRAM TEST_TRANSLATETEST
