## #############################
## Module to find COMMON package
## #############################

set(COMMON_FOUND "NO")

if(COMMON_DIR)
  # COMMON_DIR is specified
  set(COMMON_LIBRARY_DIR ${COMMON_DIR}/lib64)
  set(COMMON_MODULES_DIR ${COMMON_DIR}/mod)
elseif(DEFINED ENV{COMMON_DIR})
  # COMMON_DIR is specified
  set(COMMON_LIBRARY_DIR $ENV{COMMON_DIR}/lib64)
  set(COMMON_MODULES_DIR $ENV{COMMON_DIR}/mod)
else()
  # Otherwise look for specific places
  find_path(COMMON_LIBRARY_DIR
    NAMES libcommon.so
    PATHS
    /opt/COMMON/lib
    /usr/COMMON/lib
    /usr/lib
    ~/lib)
  find_path(COMMON_MODULES_DIR
    NAMES parallel_structures.mod
    PATHS
    /opt/COMMON/mod
    /usr/COMMON/mod
    /usr/mod
    ~/mod)
endif()

if(COMMON_LIBRARY_DIR AND COMMON_MODULES_DIR)
  set(COMMON_FOUND YES)
  find_library(COMMON_LIBRARY 
    NAMES common
    PATHS ${COMMON_LIBRARY_DIR} 
    NO_DEFAULT_PATH)
  set(COMMON_LIBRARY ${COMMON_LIBRARY})
else()
  if(COMMON_FIND_REQUIRED)
    message(FATAL_ERROR "COMMON not found, please set COMMON_DIR to your COMMON install directory : $ENV{COMMON_DIR}" )
  endif()
endif()
