## ############################
## Module to find HWLOC package
## ############################

set(HWLOC_FOUND "NO")

if(HWLOC_DIR)
  # HWLOC_DIR is specified
  set(HWLOC_LIBRARY_DIR ${HWLOC_DIR}/lib)
elseif(DEFINED ENV{HWLOC_DIR})
  # HWLOC_DIR is specified
  set(HWLOC_LIBRARY_DIR $ENV{HWLOC_DIR}/lib)
else()
  # Otherwise look for standard places
  find_path(HWLOC_LIBRARY_DIR
    NAMES libhwloc.so
    PATHS 
    /opt/HWLOC/lib
    /usr/HWLOC/lib
    /usr/lib
    ~/lib)
endif()

if(HWLOC_LIBRARY_DIR)
  set(HWLOC_FOUND YES)

  find_library(HWLOC_LIBRARY 
    NAMES hwloc
    PATHS ${HWLOC_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  set(HWLOC_LIBRARY ${HWLOC_LIBRARY})
else()
  if(HWLOC_FIND_REQUIRED)
    message(FATAL_ERROR "HWLOC not found, please set HWLOC_DIR to your HWLOC install directory")
  endif()
endif()
