## #############################
## Module to find MaPHyS package
## #############################

set(MAPHYS_FOUND "NO")

if(MAPHYS_DIR)
  # MAPHYS_DIR is specified
  set(MAPHYS_MODULES_DIR ${MAPHYS_DIR}/modules)
  set(MAPHYS_INCLUDE_DIR ${MAPHYS_DIR}/include)
  set(MAPHYS_LIBRARY_DIR ${MAPHYS_DIR}/lib)
elseif(DEFINED ENV{MAPHYS_DIR})
  # MAPHYS_DIR is specified
  set(MAPHYS_MODULES_DIR $ENV{MAPHYS_DIR}/modules)
  set(MAPHYS_INCLUDE_DIR $ENV{MAPHYS_DIR}/include)
  set(MAPHYS_LIBRARY_DIR $ENV{MAPHYS_DIR}/lib)
else()
  # Otherwise look for standard or specific places 
  find_path (MAPHYS_INCLUDE_DIR 
    NAMES mph_defs_f.h
    PATHS  
    /opt/MAPHYS/include
    /usr/MAPHYS/include
    /usr/include
    ~/include)

  find_path (MAPHYS_MODULES_DIR 
    NAMES zmph_maphys_mod.mod
    PATHS  
    /opt/MAPHYS/modules
    /usr/MAPHYS/modules
    /usr/modules
    ~/modules)

  find_path(MAPHYS_LIBRARY_DIR
    NAMES libmaphys.a
    PATHS 
    /opt/MAPHYS/lib
    /usr/MAPHYS/lib
    /usr/lib
    ~/lib)
endif()

if(MAPHYS_INCLUDE_DIR AND MAPHYS_LIBRARY_DIR AND MAPHYS_MODULES_DIR)
  set(MAPHYS_FOUND YES)

  find_library(MAPHYS_maphys_LIBRARY 
    NAMES maphys
    PATHS ${MAPHYS_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  find_library(MAPHYS_gmres_LIBRARY 
    NAMES packgmres
    PATHS ${MAPHYS_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  find_library(MAPHYS_packcg_LIBRARY 
    NAMES packcg
    PATHS ${MAPHYS_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  find_library(MAPHYS_slatec_LIBRARY 
    NAMES slatec
    PATHS ${MAPHYS_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  find_library(MAPHYS_mph_mt_tool_LIBRARY 
    NAMES mph_mt_tool
    PATHS ${MAPHYS_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  set(MAPHYS_LIBRARIES ${MAPHYS_maphys_LIBRARY} ${MAPHYS_gmres_LIBRARY} ${MAPHYS_packcg_LIBRARY} ${MAPHYS_slatec_LIBRARY} ${MAPHYS_mph_mt_tool_LIBRARY})
else()
  if(MAPHYS_FIND_REQUIRED)
    message(FATAL_ERROR "MaPHyS not found, please set MAPHYS_DIR to your MaPHyS install directory")
  endif()
endif()
