## ############################
## Module to find METIS package
## ############################

set(METIS_FOUND "NO")

if(METIS_DIR)
  # METIS_DIR is specified
  set(METIS_LIBRARY_DIR ${METIS_DIR}/libmetis)
elseif(DEFINED ENV{METIS_DIR})
  # METIS_DIR is specified
  set(METIS_LIBRARY_DIR $ENV{METIS_DIR}/libmetis)
else()
  # Otherwise look for standard or specific places
  find_path(METIS_LIBRARY_DIR
    NAMES libmetis.so
    PATHS 
    /opt/METIS/lib
    /usr/METIS/lib
    /usr/lib
    ~/lib)
endif()

if(METIS_LIBRARY_DIR)
  set(METIS_FOUND YES)

  find_library(METIS_LIBRARY 
    NAMES metis
    PATHS ${METIS_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  set(METIS_LIBRARY ${METIS_LIBRARY})
else()
  if(METIS_FIND_REQUIRED)
    message(FATAL_ERROR "METIS not found, please set METIS_DIR to your METIS install directory")
  endif()
endif()
