## #############################
## Module to find PaStiX package
## #############################

set(PASTIX_FOUND "NO")

if(PASTIX_DIR)
  # PASTIX_DIR is specified
  set(PASTIX_LIBRARY_DIR ${PASTIX_DIR}/install)
elseif(DEFINED ENV{PASTIX_DIR})
  # PASTIX_DIR is specified
  set(PASTIX_LIBRARY_DIR $ENV{PASTIX_DIR}/install)
else()
  # Otherwise look for standard or specific places
  find_path(PASTIX_LIBRARY_DIR
    NAMES libpastix.so
    PATHS 
    /opt/PASTIX/lib
    /usr/PASTIX/lib
    /usr/lib
    ~/lib)
endif()

if(PASTIX_LIBRARY_DIR)
  set(PASTIX_FOUND YES)

  find_library(PASTIX_LIBRARY 
    NAMES pastix
    PATHS ${PASTIX_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  set(PASTIX_LIBRARY ${PASTIX_LIBRARY})
else()
  if(PASTIX_FIND_REQUIRED)
    message(FATAL_ERROR "PaStiX not found, please set PASTIX_DIR to your PaStiX install directory")
  endif()
endif()
