## ############################
## Module to find SCOTCH module
## ############################

set(SCOTCH_FOUND "NO")

if(SCOTCH_DIR)
  # SCOTCH_DIR is specified
  set(SCOTCH_LIBRARY_DIR ${SCOTCH_DIR}/lib)
elseif(DEFINED ENV{SCOTCH_DIR})
  # SCOTCH_DIR is specified
  set(SCOTCH_LIBRARY_DIR $ENV{SCOTCH_DIR}/lib)
else()
  # Otherwise look for standard or specific places
  find_path(SCOTCH_LIBRARY_DIR
    NAMES libscotch.a
    PATHS 
    /opt/SCOTCH/lib
    /usr/SCOTCH/lib
    /usr/lib
    ~/lib)
endif()

if(SCOTCH_LIBRARY_DIR)
  set(SCOTCH_FOUND YES)

  find_library(SCOTCH_ESMUMPS_LIBRARY 
    NAMES esmumps
    PATHS ${SCOTCH_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  find_library(SCOTCH_SCOTCH_LIBRARY 
    NAMES scotch
    PATHS ${SCOTCH_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  find_library(SCOTCH_SCOTCHERR_LIBRARY 
    NAMES scotcherr
    PATHS ${SCOTCH_LIBRARY_DIR} 
    NO_DEFAULT_PATH)

  set(SCOTCH_LIBRARIES ${SCOTCH_ESMUMPS_LIBRARY} ${SCOTCH_SCOTCH_LIBRARY} ${SCOTCH_SCOTCHERR_LIBRARY})
else()
  if(SCOTCH_FIND_REQUIRED)
    message(FATAL_ERROR "SCOTCH not found, please set SCOTCH_DIR to your SCOTCH install directory")
  endif()
endif()
