MODULE OBSERVABLE_STRUCTURES

  !====================================================================
  ! Handle the pre- and post-processing of observables
  !====================================================================

  !--------------------------------------------------------------------
  ! Shared modules
  !--------------------------------------------------------------------
  USE ISO_C_BINDING
  !--------------------------------------------------------------------
  IMPLICIT NONE
  !--------------------------------------------------------------------

CONTAINS

  !====================================================================
  !====================================================================
  !====================================================================

  SUBROUTINE PREPROCESS_OBSERVABLES
    !------------------------------------------------------------------
    !---- Pre-processing steps for the required observables
    !
    !---- IN
    !
    !---- OUT
    !
    !------------------------------------------------------------------
    !---- Modules
    !------------------------------------------------------------------
    USE L2_ERROR
    !------------------------------------------------------------------
    !---- I/O variables
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    !---- Local variables
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    !---- Testing for bad input
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    !---- Select the right solution for L2 error processing
    !------------------------------------------------------------------
    CALL PREPROCESS_L2_ERROR
    !------------------------------------------------------------------
    !---- Testing for errors
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
  END SUBROUTINE PREPROCESS_OBSERVABLES

  !====================================================================
  !====================================================================
  !====================================================================

  SUBROUTINE POSTPROCESS_OBSERVABLES
    !------------------------------------------------------------------
    !---- Post-processing steps for the required observables
    !
    !---- IN
    !
    !---- OUT
    !
    !------------------------------------------------------------------
    !---- Modules
    !------------------------------------------------------------------
    USE IO_FIELDS
    USE L2_ERROR
    USE NUMERICAL_TYPES
    USE RCS_STRUCTURES
    !------------------------------------------------------------------
    !---- I/O variables
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    !---- Local variables
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    !---- Testing for bad input
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    !---- Post-process L2 error
    !------------------------------------------------------------------
    CALL POSTPROCESS_L2_ERROR
    !------------------------------------------------------------------
    !---- Write field
    !------------------------------------------------------------------
    IF (freq3dView) CALL WRITE_EM_FIELDS
    !------------------------------------------------------------------
    !---- Compute and write Radar Cross Section
    !------------------------------------------------------------------
    IF (computeRCS) CALL COMPUTE_RADAR_CROSS_SECTION
    !------------------------------------------------------------------
    !---- Testing for errors
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
  END SUBROUTINE POSTPROCESS_OBSERVABLES

  !====================================================================
  !====================================================================
  !====================================================================

END MODULE OBSERVABLE_STRUCTURES
